<html>
<head>
  <title>Shamir Sır Paylaşım Şeması</title>
  <meta http-equiv="Content-Type" content="text/html; charset=UTF-8" />
  <meta http-equiv="X-UA-Compatible" content="IE=edge" />
  <meta name="viewport" content="width=device-width, initial-scale=1">

  <script type="text/javascript" src="jquery-1.10.2.js"></script>
  <!--<link rel="stylesheet" type="text/css" href="bootstrap-3.3.7-dist/css/bootstrap.css">
  <script type="text/javascript" src="bootstrap-3.3.7-dist/js/bootstrap.js"></script>-->

  <script type="text/javascript" src="calculationlib/matrixlib.js"></script>
  <script type="text/javascript" src="calculationlib/ecclib.js"></script>
  <script type="text/javascript" src="calculationlib/polynomial.js"></script>
  <script type="text/javascript" src="https://cdnjs.cloudflare.com/ajax/libs/mathjax/2.7.6/MathJax.js?config=TeX-AMS-MML_HTMLorMML"></script>
  <!--<script type="text/javascript" src="MathJax/MathJax.js?config=TeX-AMS-MML_HTMLorMML"></script>-->
  <script type="text/x-mathjax-config">
    MathJax.Hub.Config({tex2jax: {inlineMath: [['$','$'], ['\\(','\\)']]}});
    MathJax.Localization.setLocale("tr");
  </script>
  <script>
    var WriteFormula = function(divId, TeX) {
      var selector = "#" + divId;
      var selObj = $(selector)
      if(selObj.length > 0){
        var queue = MathJax.Hub.queue;
        var math = MathJax.Hub.getAllJax(divId)[0];
        queue.Push(
              function () { selObj.css('visibility','hidden') },
              //["resetEquationNumbers",MathJax.InputJax.TeX],
              ["Text",math,"\\displaystyle{"+TeX+"}"],
              function () { selObj.css('visibility','visible') }
          );
      }
    }
    var AddFormula = function(container, name, tex) {
      var containerSelector = $('#' + container);
      if ($('#' + name).length == 0)
        containerSelector.append("<div id='" + name + "' style='text-align:center; visibility: visible; padding:10;'>");
      else $('#' + name).html("");

      $('#' + name).append($('<script type="math/tex">').text("\\displaystyle{"+tex+"}"));
      MathJax.Hub.Queue(
        function () { $('#' + name).css('visibility','hidden') },
        ["Typeset",MathJax.Hub],
        function () { $('#' + name).css('visibility','visible') });
    }
	var ReadMatrix = function(text) {
		
		var data = [];
		text = text.replace( /\s\s+/g, ' ' );
		var lines = text.split(/\r|\n/);
		for (var i = 0; i < lines.length; i++) {
			var lineData = [];
			var cells = lines[i].split(' ');
			for (var j = 0; j < cells.length; j++) {
				if(cells[j] != "") {
					lineData.push(parseInt(cells[j]));
				}
			}
			if (lineData.length > 0)
				data.push(lineData);
		}
		return data;
	}
  
  </script>
</head>

<body>

  <h2>Shamir Sır Paylaşım Şeması </h2>

  <h3>Sırı Oluşturma</h2>
  <div id="divConstSecretParams">
	<table>
      <tr>
        <td>  <strong>q</strong>  </td>
        <td>  <input type="text" id="txtQ" value="17"/> $ 1 \lt K \lt N \lt q $ </td>
      </tr>
      <tr>
        <td>  <strong>K</strong>  </td>
        <td>  <input type="text" id="txtK" value="6"/>  </td>
      </tr>
      <tr>
        <td>  <strong>N</strong>  </td>
        <td>  <input type="text" id="txtN" value="10"/>  </td>
      </tr>
      <tr>
        <td>  <strong>Sır</strong>  </td>
        <td>  <input type="text" id="txtSecret" value="3"/> $ s \in F_{q} $ </td>
      </tr>
      <tr>
        <td> </td>
        <td>  <input type="button" id="btnConstructSecret" value="Sırrı Oluştur" />  </tr>
      </tr>
	</table>
  </div>
  <div id="divConstSecretResult"></div>

  <h3>Sırrı Çözme</h3>
  <div id="divFindSecretParams">
    <b>q:</b> <input type='text' id='txtQ2' value='17'/> <br />
    <div id="divSecretInputs"></div>
    <input type='button' id='btnFindSecret' value='Sırrı Bul' />
  </div>
  <div id="divFindSecretResult"></div>


  <script type="text/javascript">
    var CreateInput = function(inputCount, q) {

      var text = "<table>";

      text += "<tr>";
      for (var i = 1; i < inputCount+1; i++)
        text += "<td align='center'>" + i + "</td>";
      text += "</tr>";

      text += "<tr>";
      for (var i = 1; i < inputCount+1; i++)
        text += "<td><input type='text' style='text-align:center;' maxlength='4' size='4' num=" + i + " id='txtInpt" + i + "' /></td>";
      text += "</tr>";

      text += "</table>";
      return text;
    }

		$(document).ready(function () {
			$("input[type='button']").click(function (e) {
				if (e.target.id == "btnConstructSecret") {

					var q = parseInt($('#txtQ').val());
          var K = parseInt($('#txtK').val());
          var N = parseInt($('#txtN').val());
          var secret = parseInt($('#txtSecret').val());

          var degreeOfPolynomial = K - 1;
          var polynomArray = [];
          for (var i = 0; i < degreeOfPolynomial; i++)
            polynomArray.push(parseInt(Math.random() * q));
          polynomArray.push(secret);
          while (polynomArray[0] == 0)
            polynomArray[0] = parseInt(Math.random() * q);
					var polynom = new Polynomial(polynomArray, q);

					var polynomText = "f(" + polynom.Symbol + ")=";
					polynomText += polynom.Text;
					AddFormula("divConstSecretResult", "MathOutput1", polynomText);

          var shareText = "";
          for (var i = 1; i <= N; i++)
            shareText += "f(" + i + ")=" + polynom.Calculate(i) + "\\\\";

          AddFormula("divConstSecretResult", "MathOutput2", shareText);

          $('#txtQ2').val(q);
          $("#divSecretInputs").html(CreateInput(N, q));

          WriteFormula("MathOutput3", "");
          WriteFormula("MathOutput4", "");

				}
        else if (e.target.id == "btnFindSecret") {

          var q = parseInt($('#txtQ2').val());
          var data = [];
          $("[id^=txtInpt]").each(function() {
            if (!isNaN(parseInt($(this).val())))
              data.push([parseInt($(this).attr('num')), parseInt($(this).val())]);
          });

          var interpolation = new Interpolation(q);
          var polynom = interpolation.Polynomial(data);

          var polynomText = "f(" + polynom.Symbol + ")=";
					polynomText += polynom.Text;
					AddFormula("divFindSecretResult", "MathOutput3", polynomText);

          secret = "Sır:" + polynom.Calculate(0);
          AddFormula("divFindSecretResult", "MathOutput4", secret);
        }
			});
    });
	</script>
</body>

</html>
